theory NikOpNaive
imports NikInstructions

begin
(*
 *  Naïve attempt to define the semantics of the instructions
 *  using a recursive function.
 *  This function cannot be defined properly because in case
 *  of a while, it is impossible to prove the termination of
 *  the function.
 *  The proper way to do this is explained in theories 
 *  NikSmallStep and NikBigStep.
 *)
fun execute:: "instruction \<Rightarrow> state \<Rightarrow> state"
where
    "execute Nop s = s"
  | "execute (var v) s = s(v:=0)" 
  | "execute (v <- e) s = s(v:=evaluate e s)"
  | "execute (i1;; i2) s = (
       let post1 = (execute i1 s) in
       (execute i2 post1) )"
  | "execute (if c then i1 else i2 fi) s = 
       (if (evalbool c s) then (execute i1 s) else (execute i2 s))"
  | "execute (while c do body done) s = 
       (if (evalbool c s) then
          let post = (execute body s) in
            (execute (while c do body done) post)
        else s )"
(* No way to prove termination! *)
termination sorry

end
